'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.updatePublishPackageConfig = exports.restorePackageConfig = exports.installProductionModules = exports.backupPackageConfig = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _child_process = require('child_process');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _paths = require('./paths');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var backupPackageConfig = undefined,
    fileExists = undefined,
    installProductionModules = undefined,
    restorePackageConfig = undefined,
    updatePublishPackageConfig = undefined;

fileExists = function (path) {
    try {
        _fs2.default.statSync(path);

        return true;
    } catch (e) {}

    return false;
};

exports.backupPackageConfig = backupPackageConfig = function () {
    if (!fileExists(_paths.packagePath)) {
        throw new Error('./' + _path2.default.basename(_paths.packagePath) + ' does not exist.');
    }

    if (fileExists(_paths.packageBackupPath)) {
        throw new Error('./' + _path2.default.basename(_paths.packageBackupPath) + ' already exists.');
    }

    _fsExtra2.default.copySync(_paths.packagePath, _paths.packageBackupPath);
};

exports.restorePackageConfig = restorePackageConfig = function () {
    if (!fileExists(_paths.packageBackupPath)) {
        throw new Error('./' + _path2.default.basename(_paths.packageBackupPath) + ' does not exist.');
    }

    _fsExtra2.default.copySync(_paths.packageBackupPath, _paths.packagePath);

    _fsExtra2.default.removeSync(_paths.packageBackupPath);
};

exports.updatePublishPackageConfig = updatePublishPackageConfig = function () {
    var packageConfig = undefined;

    packageConfig = _fsExtra2.default.readJsonSync(_paths.packagePath);

    packageConfig.scripts = packageConfig.scripts || {};
    packageConfig.scripts.postinstall = packageConfig.scripts.postinstall || '';
    packageConfig.scripts.postinstall += '; rm -fr ./node_modules; mv ./bundled_modules ./node_modules';

    packageConfig.dependencies = {};
    packageConfig.devDependencies = {};

    _fsExtra2.default.writeJsonSync(_paths.packagePath, packageConfig);
};

exports.installProductionModules = installProductionModules = function () {
    (0, _child_process.execSync)('npm install --production', {
        cwd: process.cwd()
    });
};

exports.backupPackageConfig = backupPackageConfig;
exports.installProductionModules = installProductionModules;
exports.restorePackageConfig = restorePackageConfig;
exports.updatePublishPackageConfig = updatePublishPackageConfig;
//# sourceMappingURL=utils.js.map
